/* Copyright (c) 2001 by David Chiang. All rights reserved.*/

#ifndef COUNT_H
#define COUNT_H

struct count_hash_node {
  int *ks;
  struct count_hash_node *next;
  double c; /* must go last, because we might store multiple elements here */
};

typedef struct _count {
  int n; /* size of each event vector */
  int d;
  int size, nelem; /* size of table, number of elements */
  struct count_hash_node **t;

  int lookups, hits;
} *count;

#define DEFAULT_SIZE 10000
#define MAX_DEPTH 32
#define LOAD_FACTOR 1.0

count new_count(int n, int d);
int count_read(count ct, const char *filename);
void count_delete(count ct);
int count_count(count ct, int ks[], int i, double delta, double *ptotal);
int count_write(count ct, const char *filename);
int count_insert(count ct, int ks[], double c[]);
double count_lookup(count ct, int ks[], int i);
double * count_mlookup(count ct, int ks[]);

#endif
