/* Copyright (c) 2001 by David Chiang. All rights reserved.*/

#ifndef DICT_H
#define DICT_H

#include <stdio.h>

#define MAX_LENGTH 255
#define UNKNOWN -1

typedef struct {
  int m;
  const char **t;
} *dict;

dict new_dict(int m);
dict read_dict(FILE *fp);
void dict_delete(dict d);
int dict_write(dict d, FILE *fp);
int dict_insert(dict d, const char *k);
int dict_lookup(dict d, const char *k);
int dict_rlookup(dict d, int i, char *buf, int buf_size);

#endif
