/* Copyright (c) 2001 by David Chiang. All rights reserved.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "prob.h"

int read_profile(const char *prefix, prob *p, int n_p) {
  int table;
  FILE *profp;  
  int i, j, k, m, n, flags[MAX_DEPTH];
  char filename[FILENAME_MAX], buf[1024], *names[MAX_DEPTH];
  int cont;
  prob *pp;

  /* Open the profile */
  sprintf(filename, "%s.pro", prefix);
  profp = fopen(filename, "r");

  table = 0;
  pp = &p[table];

  fgets (buf, sizeof(buf), profp);
  while (!feof(profp)) {

    i = 0;
    j = 0;
    k = 0;
    m = -1;

    if (!strchr(buf, '|')) {
      fgets (buf, sizeof(buf), profp);
      continue;
    }

    while (i<sizeof(buf) && buf[i] != '\0' && !isspace(buf[i]) && buf[i] != '*') {

      if (buf[i] == ';' || buf[i] == ',' || buf[i] == '|') {

	if (buf[i] == '|')
	  m = k+1;
	else if (m > 0)
	  flags[k-m] = (buf[i] == ';');

	buf[i] = '\0';
	names[k] = strdup(buf+j);
	
	j = i+1;
	k++;
      }

      i++;

    }

    cont = (buf[i] == '*');

    buf[i] = '\0';
    names[k] = buf+j;
    if (m > 0)
      flags[k-m] = 1;
    n = k+1;
      
    /* Show result */
    fprintf (stderr, "%d. ", table);

    for (i=0; i<n; i++) {
      fprintf (stderr, "%s", names[i]);
      if (i == m-1)
	fprintf (stderr, "|");
      else if (i >= m && flags[i-m])
	fprintf (stderr, ";");
      else
	fprintf (stderr, ",");
    }
    fprintf(stderr, "\n");
    
    if (pp)
      *pp = new_prob(m, n, flags, names);
    if (cont)
      pp = &(*pp)->next;
    else {
      table++;
      if (table<n_p)
	pp = &p[table];
      else
	pp = NULL;
    }

    fgets (buf, sizeof(buf), profp);
  }

  fclose(profp);

  return table;

}

