/* Copyright (c) 2001 by David Chiang. All rights reserved.*/

#include <stdlib.h>
#include "vector.h"

int vector_hash(int ks[], int n, int max) {
  int i, hash, *pk;

  hash = 0;
  for (i=0, pk = ks; i<n; i++, pk++) {
    hash = (hash * 2 + *pk + 1);
    if (hash & 0x40000000)
      hash = hash % max;
  }

  return hash % max;
}

int vector_multihash(int ks[], int n, int max, int hs[]) {
  int i, hash, *pk, *ph;

  hash = 0;
  for (i=0, pk = ks, ph = hs; i<n; i++, pk++, ph++) {
    hash = (hash * 2 + *pk + 1) % max;
    *ph = hash;
  }

  return 0;
}

int vector_compare(int *ks1, int *ks2, int n) {
  int i, *pk1, *pk2;

/*  if (ks2 == NULL)
    return 1;
  else if (ks1 == NULL)
    return -1;*/

  for (i=0, pk1 = ks1, pk2 = ks2; i<n; i++, pk1++, pk2++) {
    if (*pk1 == *pk2)
      continue;
    else if (*pk1 > *pk2)
      return 1;
    else 
      return -1;
  }

  return 0;
}
