/* Copyright (c) 2001 by David Chiang. All rights reserved.*/

#ifndef HASH_MAP_H
#define HASH_MAP_H

#include "list.h"
#include "generic.h"

typedef struct {
  list_node *bucket;
  int size, nelem;
  _COMPARE(compare);
  _HASH(hash);

  int accounting;
  int lookups, lookup_time;
} *hash_map;

struct hash_map_entry {
  void *key;
  void *value;
};

hash_map new_hash_map(_COMPARE(compare), _HASH(hash));
void hash_map_delete(hash_map ht);
void ** hash_map_lookup(hash_map ht, void *key, int create);
list_node hash_map_similar(hash_map ht, unsigned int hash);

#define HASH_LOAD_FACTOR 1.0
#define HASH_INITIAL_SIZE 89

#endif
