/* Copyright (c) 2001 by David Chiang. All rights reserved.*/

#include <stdlib.h>

#include "list.h"
#include "generic.h"

list_node new_list_node (void *contents, list_node next) {
  list_node l = malloc(sizeof(*l));
  l->contents = contents;
  l->next = next;
  return l;
}

void list_node_delete(list_node l) {
  free(l);
}

void list_delete(list_node l) {
  if (l != NULL) {
    list_delete(l->next);
    list_node_delete(l);
  }
}

void list_map(list_node l, _ENDO(f)) {
  if (l != NULL) {
    l->contents = (*f) (l->contents);
    list_map(l->next, f);
  }
}

/* Destructively concatenates l2 onto l1. */

list_node list_nconc(list_node l1, list_node l2) {
  list_node li;

  if (l1 == NULL)
    return l2;

  li = l1;
  while (li->next != NULL)
    li = li->next;

  li->next = l2;
  return li;
}

