#ifndef ELEM_LABEL_H
#define ELEM_LABEL_H

#include "grammar.h"

typedef struct {
  int label;
  struct grammar_entry *pge;
  int oheadword, headword, headtag;
  int d_addr, d_type;
  int type, spine, noadj, empty, anchor;

  int virtual;
#define LEFT 1
#define RIGHT 2

  float pp;

} *elem_label;

elem_label new_elem_label(void);
elem_label elem_label_copy(elem_label sn);
void elem_label_delete(elem_label sn);
elem_label elem_term_from_string(const char *s);
elem_label elem_nonterm_from_string(const char *s);
int elem_label_to_string(elem_label sn, char *s, size_t n);

#endif
