#ifndef ELEM_NODE_H
#define ELEM_NODE_H

#include "elem_label.h"
#include "node.h"

int node_type(node n);
#define INTERIOR 1
#define FOOT 2
#define SUBST 3
#define FRONTIER 4

#define node_isroot(n) (node_parent(n) == NULL)

int node_visible(node n);
int node_empty(node n);

int node_adjoinable(node n1, node n2);
int node_substitutable(node n, node s);
int node_spine(node n);

int node_label(node n);

/* Left and right sisters (not children) */
node node_left(node n);
node node_right(node n);

void node_print(node n);

int tree_type(node r);
#define LEFTMOD 0
#define RIGHTMOD 0
#define LEFTPRED 2
#define RIGHTPRED 3
#define INITIAL 0

#endif
