/* Copyright (c) 2001 by David Chiang. All rights reserved.*/

#ifndef GRAMMAR_H
#define GRAMMAR_H

#include "node.h"
#include "list.h"

struct grammar_entry {
  int treeType;
  int d_index;
  node root;
};

struct word {
  int ow, w;
  char *word;
  int *t, n_t;
  node derived_node;
};

int word_compare(struct word *w1, struct word *w2);
unsigned int word_hash(struct word *w);
int word_merge(struct word *w1, struct word *w2);
void write_word(FILE *fp, struct word *w);
struct word * read_word(FILE *fp);


node tree_root(void *tree);

extern list_node grammar;
int read_grammar(const char *prefix);
void delete_grammar(void);

list_node growTrees(struct word *w[], int n);
void deleteTrees(list_node subgrammar);


#endif
