/* Copyright (c) 2001 by David Chiang. All rights reserved.*/

#ifndef PARSER_H
#define PARSER_H

#include "dict.h"
#include "model.h"
#include "node.h"
#include "grammar.h"

extern dict d;
#define MAX_WORDS 250

typedef struct _item {
  node n;
  code_t code;
  float p, p_prior;
  float p_inside, p_outside;

  int i, j; /* these are just for printing. and for reconstruct() */

  /* These are for storing the derivation history */
  int action;
  struct _item *ant1, *ant2;
  struct _item *next;

  /* This is for when the derived tree is given */
  node derived_node;
} *item;

#define ACTION_PUSH 1
#define ACTION_POP 2
#define ACTION_NODE 3
#define ACTION_NONE 0

int read_sent(FILE *fp, struct word *w[], int n);

#endif
