#ifndef ITEM_H
#define ITEM_H

#include "node.h"
#include "model.h"

typedef struct {
  node n, dn1, dn2, df;
  code_t code;
  double p_inside, p_outside, p_viterbi;  
  int flag;
  list_node inferences;
} *item;

struct inference {
  int op;
  double p;
#define OP_NULL 0
#define OP_ADJ 1 
#define OP_SADJ 2
#define OP_SUBST 3
#define OP_INITIAL 4
#define OP_NOADJ 5
#define OP_STOPSADJ 6

  item ant1, ant2;
};

int item_compare(item, item);
unsigned int item_r_hash(item);
unsigned int item_a_hash(item);
void item_merge(item, item);

void item_delete(item it);

#endif
