#ifndef LEXICON_H
#define LEXICON_H

#include "hash_map.h"
#include "generic.h"
#include "stdio.h"

struct lex_entry {
  int id, count;
  void *key; /* hideous! */
};

typedef hash_map lexicon;

lexicon new_lexicon(_COMPARE(compare), _HASH(hash));
void * lexicon_insert(lexicon lex, void *x);
void * lexicon_lookup(lexicon lex, void *x);
int lexicon_count(lexicon lex, void *x);
int lexicon_id(lexicon lex, void *x);
void * lexicon_retrieve(lexicon lex, int id);
int lexicon_write(lexicon lex, FILE *fp, _WRITE(writer));
int lexicon_read(lexicon lex, FILE *fp, _READ(reader));
int lexicon_size(lexicon lex);

typedef struct {
  lexicon l;
  int hash;
  list_node cur;
} *lexiconIterator;

lexiconIterator new_lexiconIterator(lexicon l);
int lexiconIterator_hasNext(lexiconIterator li);
void * lexiconIterator_next(lexiconIterator li);

#endif
