/* Copyright (c) 2001 by David Chiang. All rights reserved.*/

#include <stdlib.h>
#include <string.h>

#include "node.h"

extern int punct(node cur);
extern int preterm(node cur);

void raise_punct(node cur) {
  int i, n;

  n = node_n_children(cur);

  for (i=0; i<n; i++)
    raise_punct(node_child(cur, i));

  if (node_parent(cur) == NULL)
    return;

  while (node_n_children(cur) > 0 && punct(node_child(cur, 0)) && preterm(node_child(cur, 0)))
    node_insert_child(node_parent(cur), node_order(cur), node_child(cur, 0));
  
  while (node_n_children(cur) > 0 && punct(node_child(cur, -1)) && preterm(node_child(cur, -1)))
    node_insert_child(node_parent(cur), node_order(cur)+1, node_child(cur, -1));

  /* Don't think this should really happen */
  if (n > 0 && node_n_children(cur) == 0)
    node_delete(cur);

}
