#include <stdlib.h>
#include <string.h>

#include "lexicon.h"
#include "node.h"
#include "treebank_label.h"

int preterm_compare(node n1, node n2) {
  char *s1, *s2;
  s1 = ((treebank_label)node_child(n1, 0)->contents)->label;
  s2 = ((treebank_label)node_child(n2, 0)->contents)->label;

  return strcmp(s1, s2);
}

int preterm_hash(node n) {
  int hash;
  char *s = ((treebank_label)node_child(n, 0)->contents)->label;

  hash = 0;
  while (*s != '\0') {
    hash = hash * 2 + *s;
    s++;
  }

  return hash;
}

void preterm_write(FILE *fp, node n) {
  tree_print(fp, n, (TO_STRING)treebank_label_to_string);
}

node preterm_read(FILE *fp) {
  return read_tree(fp, (FROM_STRING)treebank_nonterm_from_string, (FROM_STRING)treebank_term_from_string);
}

char * fold_unknown(char *s, lexicon words, int threshold) {
  static int initialized = 0;
  static treebank_label tl;
  static node cur;

  if (!initialized) {
    tl = new_treebank_label();
    cur = new_node(new_treebank_label());
    node_insert_child(cur, 0, new_node(tl));
    initialized = 1;
  }

  tl->label = s;

  if (threshold < 0 || lexicon_count(words, cur) < threshold)
    return "*UNKNOWN*";
  else
    return s;
}

