# Copyright (c) 2001 by David Chiang. All rights reserved.

if (@ARGV != 2) {
    print "Usage: $0 <tree-file> <leaf-file>\n";
    print "If either <tree-file> or <leaf-file> is -, then standard input\n";
    print "will be used.";
    die;
}

$|=1; # autoflush on

open (TREE, $ARGV[0]) || die;
open (LEAF, $ARGV[1]) || die;

$preterm = '\(([^()\s]+)\s+([^()\s]+)\)';

while ($treeline = <TREE>) {
    $leafline = <LEAF>;

    $i=0;
    while ($leafline =~ /$preterm/g) {
	$leaf[$i++] = $2;
    }
    $n = $i;

    $i=0;
    $m = $treeline =~ s/$preterm/"($1 $leaf[$i++])"/ge;
    if ($m != $n) {
	print STDERR "Warning: length unmatch ($m|$n)\n";
    }

    print $treeline;
}

