#!/pkg/bin/perl5

# Copyright (c) 2001 by David Chiang. All rights reserved.

if (@ARGV != 2) {
    print "Usage: $0 <sgml-file> <tree-file>\n";
    print "If either <sgml-file> or <tree-file> is -, then standard input\n";
    print "will be used.";
    die;
}

open (SGML, $ARGV[0]) || die;
open (PARSED, $ARGV[1]) || die;

undef $/;
$sgml = <SGML>;
$parsed = <PARSED>;


$depth = 0;
$start = 0;
$i = 0;
while ($parsed =~ /[()]/g) {
    if ($& eq "(") {
	$depth++;
    } elsif ($& eq ")") {
	$depth--;
    }

    if ($depth == 0) {
	$s[$i] = substr($parsed, $start, (pos $parsed)-$start);
	$i++;
	$start = pos $parsed;
    }
}

sub process {
    if ($_[0] =~ /^\s*(\(.*\))\s*$/) {
	print $s[$i]; print "\n";
	$i++;
    } else {
	print $_[0];
    }
}

$i = 0;
$lastpos = 0;
while ($sgml =~ /<[^>]*>/g) {
    process(substr($`, $lastpos));
    print $&; 
    $lastpos = pos $sgml;
}
process(substr($sgml, $lastpos));
