# Copyright (c) 2001 by David Chiang. All rights reserved.

# Options:
#  -n       don't replace POS tags
#  -t<num>  unknown word threshold
#  -w<name> location of words file
# Note that spaces are not allowed between option letters and their values.

$threshold = 6;
$wordsfile = "tig0.lex";

while ($_ = $ARGV[0], /^-/) {
    shift;
    last if /^--$/;
    if (/^-n/) { $dontreplace = 1; }
    if (/^-t(.*)/) { $threshold = $1; }
    if (/^-w(.*)/) { $wordsfile = $1; }
}

open WORDS, $wordsfile;
while (<WORDS>) {
     if (/(\d+)\s+(\d+)\s+\(([^\s]+)\s+([^)]+)\)/) {
	$count{$4} = $2;
	foreach $tag (split(/\|/, $3)) {
	    $tags{$4}{$tag}++;
	}
    }
}

sub process {
    if ($dontreplace) {
	%t = ($_[0] => 1);
    } else {
	%t = %{$tags{$_[1]}};
    }

    if ($count{$_[1]} >= $threshold) {
	$w = $_[1];
    } else {
	$w = "*UNKNOWN*";
	$t{$_[0]}++;
    }

    return "(" . join ("|", keys %t) . " $w)";
}

while (<>) {
    s/\(\s*([^() ]+)\s([^() ]+)\s*\)/process($1,$2)/ge;

    print;
}
